unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, nb;

type
  TForm1 = class(TForm)
    Button1: TButton;
    NetBIOSLabel: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    function NbGetMacAddr(Name:String; LanaNum: Integer): String;
    function NbLanaEnum: TLana_Enum;
    function NbReset(l: Byte): Word;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
 L_Enum : TLana_Enum;
 i:Integer;
begin
 L_Enum := NbLanaEnum;
 for i := 0 to (L_Enum.Length - 1)do
  begin
   NbReset(L_Enum.Lana[i]);
   NetBIOSLabel.Caption:=NbGetMacAddr(Edit1.Text,i);
   if NetBIOSLabel.Caption<>'?' then break;
  end;
end;

function TForm1.NbGetMacAddr(Name: String; LanaNum: Integer): String;
var
 NCB: TNCB;
 AdpStat: TAdpStat;
 RetCode: Word;
 i:Integer;
begin
 FillChar(NCB, SizeOf(NCB), 0);
 FillChar(AdpStat, SizeOf(AdpStat), 0);
 NCB.Command := NCB_ADPSTAT;
 NCB.Buf := @AdpStat;
 NCB.Length := Sizeof(AdpStat);
 FillChar(NCB.CallName, Sizeof(TNBName), $20);
//  NCB.CallName[0] := Byte('*');

 for i:=0 to Length(Name)-1 do
  NCB.CallName[i] := Byte(Name[i+1]);
 NCB.Lana_Num := LanaNum;
 RetCode := NetBiosCmd(NCB);
 if RetCode = NRC_GOODRET then
  begin
   Result := Format('%2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x',
             [AdpStat.ID[0], AdpStat.ID[1], AdpStat.ID[2],AdpStat.ID[3],
              AdpStat.ID[4], AdpStat.ID[5]]);
  end
 else
  begin
   Result := '?';
  end;
end;

function TForm1.NbLanaEnum: TLana_Enum;
var
 NCB: TNCB;
 L_Enum: TLana_Enum;
 RetCode: Word;
begin
 FillChar(NCB, SizeOf(NCB), 0);
 FillChar(L_Enum, SizeOf(TLana_Enum), 0);
 NCB.Command := NCB_ENUM;
 NCB.Buf := @L_Enum;
 NCB.Length := Sizeof(L_Enum);
 RetCode := NetBiosCmd(NCB);
 if RetCode <> NRC_GOODRET then
  begin
   L_Enum.Length := 0;
   L_Enum.Lana[0] := Byte(RetCode);
  end;
 Result := L_Enum;
end;

function TForm1.NbReset(l: Byte): Word;
var
 NCB: TNCB;
begin
 FillChar(NCB, SizeOf(NCB), 0);
 NCB.Command := NCB_RESET;
 NCB.Lana_Num := l;
 Result := NetBiosCmd(NCB);
end;

end.
